﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;


using Excel = Microsoft.Office.Interop.Excel;

using Word = Microsoft.Office.Interop.Word;

using PowerPoint = Microsoft.Office.Interop.PowerPoint;


namespace Office1
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void bnBspExcel1_Click(object sender, EventArgs e)
        {
            var xl = new Excel.Application();
            xl.Workbooks.Add();
            xl.Visible = true;
            xl.Cells[1, 1] = "Zahl1";//Row,Column
            xl.Cells[1, 2] = "Zahl2";
            for (int row = 2; row <= 101; row++)
            {
                xl.Cells[row, 1] = (100 + row).ToString();
                xl.Cells[row, 2] = (123 - row).ToString();
            }
            xl.Cells[4, 1].Select();
            for (int row = 2; row < 101; row++)
            {
                xl.Cells[row, 1].Select();
                xl.ActiveCell.Interior.Color = Color.Yellow;
                xl.ActiveCell.Font.Color = Color.Red;

                xl.ActiveCell.Font.Name = "Times New Roman";
                xl.ActiveCell.Font.Size = 14;
                xl.ActiveCell.Font.Bold = true;
            }
            xl.Range["B8:B12"].Select();

            xl.Selection.Font.Underline =
                Excel.XlUnderlineStyle.xlUnderlineStyleSingle;

            /*
             * Selection.Font.Underline = 
             * xlUnderlineStyleSingle
             * */
        }

        private void bnBspExcel2_Click(object sender, EventArgs e)
        {
            var xl = new Excel.Application();
            xl.Workbooks.Add();
            xl.Visible = true;
            for (int col = 1; col <= 10; col++)
            {
                xl.Cells[1, col] = "Zahl" + col;//Row,Column
                xl.Cells[1, col].Select();
                xl.ActiveCell.Interior.Color = Color.Yellow;
                xl.ActiveCell.Font.Color = Color.Red;

                xl.ActiveCell.Font.Name = "Times New Roman";
                xl.ActiveCell.Font.Size = 14;
                xl.ActiveCell.Font.Bold = true;
            }
            for (int col = 1; col <= 10; col++)
            {
                for (int row = 2; row <= 201; row++)
                {
                    xl.Cells[row, col] = row;//Row,Column
                }
            }
            for (int col = 1; col <= 10; col++)
            {
                for (int row = 2; row <= 201; row++)
                {
                    if ((row + col) % 50 == 0)
                    {
                        xl.Cells[row, col].Interior.Color = Color.Red;
                    }
                }
            }
        }

        private void bnBspExcelFormel_Click(object sender, EventArgs e)
        {
            var xl = new Excel.Application();
            xl.Workbooks.Add();
            xl.Visible = true;
            xl.Cells[1, 1] = "1. Zahlen";
            xl.Cells[1, 2] = "2. Zahlen";
            xl.Cells[1, 3] = "Summe";
            int n = 10;
            int start = 2;
            for (int row = start; row < start + n; row++)
            {
                xl.Cells[row, 1] = row + 3;
                xl.Cells[row, 2] = row + 4;
            }
            // xl.Cells[start+n, 1].Select();
            // xl.Cells[start+n, 1].Formula = "=SUM(A"+start+":B"+(start+n-1)+")";
            // fehler  xl.ActiveCell.FormulaR1C1 = "=SUM(R[\"A"+start+":A"+(start+n-1).ToString()+"\"])";
            xl.Cells[start + n, 1].FormulaR1C1 = "=SUM(R[-" + n + "]C:R[-1]C)";
            for (int row = start; row < start + n; row++)
            {
                xl.Cells[row, 3].Formula = "=SUM(A" + row + ":B" + (row) + ")";
            }
        }

        private void bnWord1_Click(object sender, EventArgs e)
        {
            var word = new Word.Application();
            word.Visible = true;

            Word.Document doc = word.Documents.Add();

            word.Selection.TypeText("Hello World");  // Eingabetext

            word.Selection.TypeParagraph();
            word.Selection.Font.Color = Word.WdColor.wdColorRed;
            word.Selection.Font.Name = "Times New Roman";
            word.Selection.Font.Size = 14;
            word.Selection.Font.Bold = 1;
            word.Selection.TypeText("C Sharp\tist\t\r\ntoll");  // Eingabetext mit Tab´s und Zeilenumbruch

            word.Selection.TypeText("C Sharp\tist\t\r\ntoll");
            word.Selection.TypeText("C Sharp\tist\t\r\ntoll");

            word.Selection.Font.Color = Word.WdColor.wdColorBlack;

            Word.Range tableLocation = doc.Range(word.Selection.Start, word.Selection.Start);
            Microsoft.Office.Interop.Word.Table table
                = doc.Tables.Add(Range: tableLocation,
                NumRows: 50, NumColumns: 4);

            //table.Borders.Enable = 1;
            table.Borders.InsideLineStyle
                = Word.WdLineStyle.wdLineStyleDouble;
            table.Borders.OutsideLineStyle
                = Word.WdLineStyle.wdLineStyleEmboss3D;
            // wdUnderlineDouble


            /*
             * .LineStyle = Options.DefaultBorderLineStyle
        .LineWidth = Options.DefaultBorderLineWidth
        .Color = Options.DefaultBorderColor
             */

            // Überschrift-Format
            for (int col = 1; col <= 4; col++)
            {
                Word.Cell cell = table.Cell(1, col);
                cell.Range.Font.Bold = 1;
                cell.Range.Font.Size = 14;
                cell.Range.Font.Color =
                Word.WdColor.wdColorBlue;
                cell.Range.Text = "Col " + col;
            }
            for (int row = 2; row <= 50; row++)
            {
                for (int col = 1; col <= 4; col++)
                {
                    Word.Cell cell = table.Cell(row, col);
                    cell.Range.Text = (row * 100 + col).ToString();
                }
            }
            //Selection.MoveDown Unit:=wdLine, Count:=3
            //Selection.HomeKey Unit:=wdLine
            //Selection.MoveRight Unit:=wdCharacter, Count:=9, Extend:=wdExtend
            //Selection.Rows.HeadingFormat = True

            // Die Tabelleüberschrift wird auf die nächsten Seite übertragen
            table.Rows[1].HeadingFormat = -1;

        }

        private void bnPowerPoint1_Click(object sender, EventArgs e)
        {
            var power = new PowerPoint.Application();
            power.Visible = Microsoft.Office.Core.MsoTriState.msoTrue;  // Verweis  "Office" Eintrag,
            PowerPoint.Presentation pptPreso = power.Presentations.Add();



            //PowerPoint.Application power2 = new PowerPoint.Application();
            //PowerPoint.Presentation pptPreso2 = power2.Presentations.Add();


            Microsoft.Office.Interop.PowerPoint.Slides slides;
            Microsoft.Office.Interop.PowerPoint._Slide slide;
            Microsoft.Office.Interop.PowerPoint.TextRange objText;

            PowerPoint.CustomLayout customLayout = pptPreso.SlideMaster.CustomLayouts[PowerPoint.PpSlideLayout.ppLayoutText];

            slides = pptPreso.Slides;
            slide = slides.AddSlide(1, customLayout);

            // Add title
            objText = slide.Shapes[1].TextFrame.TextRange;
            objText.Text = "C# mit PowerPoint";
            objText.Font.Name = "Arial";
            objText.Font.Size = 32;

            objText = slide.Shapes[2].TextFrame.TextRange;
            objText.Text = "Dynamisch erzeugter Text\n2. Zeile\n3. Zeile";

            slide.NotesPage.Shapes[2].TextFrame.TextRange.Text = "Dies ist eine Notiz";

            for (int i = 0; i < 10; i++)
            {
                int n = pptPreso.Slides.Count + 1;
                slide = slides.AddSlide(n, customLayout);
                objText = slide.Shapes[2].TextFrame.TextRange;
                objText.Text = "Dies ist die " + n + ". Folie";
                objText.Font.Name = "Arial";
                objText.Font.Size = 32;
            }
            // pptPreso.Close();
            //pptPreso.Quit();

        }

    }
}
